<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use ZeedhiUser\Services\AccessControl\Environment;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Services\PerfilAcessoRepository;

class PerfilAcessoController extends \ZeedhiUser\Controllers\General\ZhuCrud {

    protected $dataSourceName = "perfilacesso";
    protected $perfilAcessoRepository;
    protected $maxNRPERFACESSO;

    public function __construct(Manager $dataSourceManager, Environment $environment,
                                ParameterBag $parameterBag, PerfilAcessoRepository $PerfilAcessoRepository) {
        $this->PerfilAcessoRepository = $PerfilAcessoRepository;

        parent::__construct($dataSourceManager, $environment, $parameterBag);
    }

    public function save(DTO\Request\DataSet $request, DTO\Response $response) {

    	$index = 1;
        try {
    		 $perfilmax = $this->PerfilAcessoRepository->getMaxNrPerfilAcesso();
    		 $maxNRPERFACESSO = $perfilmax[0]['MAXNRPERFILACESSO'];
    		
    		 
    		
        }
        catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage()));
            $maxNRPERFACESSO = 1;
        }

        foreach($request->getDataSet()->getRows() as $row) {
          	if (($row->get('__is_new'))) {
                $row->set("DTVALPERFILPARC", null);
	            $nmperfilacesso = $row->get("NMPERFILACESSO");
	            $nrorg = 1;           
	            $idativo = 'S';
	            $nrusergroup = 1;
	            $nrperfacessopai = null;
	            $nrperfilacesso = $maxNRPERFACESSO+$index;
	            $index++;
	            $PERFIL = $this->PerfilAcessoRepository->salvaPerfilAcesso($nmperfilacesso, $nrorg, $idativo, $nrusergroup,
					$nrperfilacesso);
				$rows = array('NRPERFILACESSO' => $nrperfilacesso);
				 
            }else{
            	$nmperfilacesso = $row->get("NMPERFILACESSO");
            	$nrperfilacesso = $row->get("NRPERFILACESSO");
            	$nrorg = 1;  
            	$this->PerfilAcessoRepository->alteraPerfilAcesso($nmperfilacesso, $nrorg, $nrperfilacesso);   
            	$rows = array('NRPERFILACESSO' => $nrperfilacesso);
            	
            }
        }
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('perfilacesso', array($rows)));       
            
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
    	$rows = $request->getDataSet()->getRows();
    	foreach ($rows as $row) {
    	    $perfisToDelete[] = $row->get("NRPERFILACESSO");
    	    $nrperfil = $row->get("NRPERFILACESSO");
    	    $this->PerfilAcessoRepository->deleteAssocietedRules($nrperfil);
        	$this->PerfilAcessoRepository->deleteAssocietedPerfAcessParc($nrperfil);
        	$this->PerfilAcessoRepository->deletaPerfilAcesso($nrperfil);
        	
        }
        try {
       	
        	$rows = $perfisToDelete;
		    $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('perfilacesso', array($rows)));
        }catch (\Exception $e) {
		        $response->addMessage(new DTO\Response\Message($e->getMessage()));
		}
    }
   

    public function find(DTO\Request\Filter $request, DTO\Response $response){
       	$rows = $this->PerfilAcessoRepository->getAllPerfAcesso();
    	$response->addDataSet(new DataSet($this->dataSourceName, $rows));
    }

    public function searchOperador(DTO\Request\Filter $request, DTO\Response $response){
    	$params = $request->getFilterCriteria()->getConditions();
    	foreach ($params as $value) {
    		$operadores = $value['value'];
    	}
    	if(is_array($operadores)){
    		$rows = $this->PerfilAcessoRepository->getOperador($operadores);
    	}else{
    		$rows = $this->PerfilAcessoRepository->getAllOperador();
    	}
    	
    	$response->addDataSet(new DataSet($this->dataSourceName, $rows));
    }
}