<?php

namespace Teknisa\MAN\Services;

abstract class AProcessLogger {
    
    protected $processMessages;
    protected $exceptionMessages;
    
    protected $logStartDate;
    protected $logFolderPath;
    
    public function __construct ( $logFolderPath, $logStartDate ) {
        $this->logFolderPath = $logFolderPath;
        $this->logStartDate = $logStartDate;
    }
    
    public function saveProcessLog ( $messageId, $additionalInfo = '', $codReferencia = '' ) {
        $fileName = $this->logFolderPath . $this->logStartDate .'_'.$codReferencia .'_processes.txt';
        $this->appendIntoFile( $fileName, $this->formatLogMessage( $this->processMessages[$messageId] . $additionalInfo . "\nMemory Usage : " . memory_get_usage() ));
    }
    
    public function saveExceptionLog ( $messageId, $exception, $codReferencia = '' ) {
        $fileName = $this->logFolderPath . $this->logStartDate .'_'.$codReferencia .'_exceptions.txt';
        $this->appendIntoFile( $fileName, $this->formatLogMessage( $this->exceptionMessages[$messageId] . $exception->getMessage() ));
    }
    
    private function formatLogMessage( $message ) {
        return "----------------------------\n\n$message\n\n----------------------------\n\n"; 
    }
    
    private function appendIntoFile( $fileName, $fileContent ) {
        if(!file_put_contents($fileName, $fileContent, FILE_APPEND)) 
            throw new \Exception($fileName . " não foi salvo! Um erro inseperado ocorreu! \n");
    }
    
}